/*
   ; A very basic c++ test
   ; =======================

   ;------------------------------------------------------------------------
   ; Author:    Olivier Carmona 28/01/00
   ;
   ; Project:   KHEPERA
   ; Goal:              Demo of a C++ application.
   ;                    This application shows how to launch processes and 
   ;                    some basic C++ manipulation.
   ;
   ; This module is (c) of Olivier Carmona 2000
   ; carmona@k-team.com
   ;
   ;------------------------------------------------------------------------
 */

#include	<sys/kos.h>
#include 	<iostream.h>
#include 	<stdio.h>

#define endl "\r\n"

class point
{
  int x, y;
    public:
    point (int abs = 1, int ord = 0)	//constructeur de la classe
   {
    x = abs;
    y = ord;
    cout << "Constructeur de la classe " << x << " " << y << endl;
  }
  point (point &);		//constructeur par recopie

  ~point ();
};

point::point (point & p)
{
  cout << "Constructeur par recopie " << p.x << " " << p.y << endl;
  x = p.x;
  y = p.y;
}

point::~point ()
{
  cout << "Destructeur " << x << " " << y << endl;
}

class Rectangle
{
  int width;
  int height;
    public:
    Rectangle (int w, int h):width (w), height (h)
  {
  }
  int area ()
  {
    return width * height;
  }
  virtual char *mytype ()
  {
    return "Rectangle";
  }
};

class Square:public Rectangle
{
  public:
  Square (int side):Rectangle (side, side)
  {
  }
  char *mytype ()
  {
    return "Square";
  }
};

Rectangle *r[10];

void
output_area ()
{
  for (int i = 0; i < 10; i++)
    cout << "Object number " << i << " has area of " << r[i]->area () << endl
;
}
void
output_types ()
{
  for (int i = 0; i < 10; i++)
    cout << "Object number " << i << " is a " << r[i]->mytype () << endl
;
}


/*
 * Process 0
 * ^^^^^^^^^
 *
 * This process changes the state of the LED 0
 * every 500 ms.
 *
 */

void
process_0 ()
{

  for (;;)
    {
      tim_suspend_task (500);
      var_change_led (0);
    }
}

/*
 * Process 1
 * ^^^^^^^^^
 *
 * This process shows some typical C++ operations
 * every 1000 ms.
 *
 */

void
process_1 (void)
{
  point a;			// Default constructor call
  point b (2);			// Call constructor with parameters.
  point c (a);			// Constructor by copy.
  point d (5, 2);		// Call constructor with parameters.
  point e (4, 2);		// Call constructor with parameters.

  char answer;

  for (int i = 0; i < 10; i++)
    {
      cout << "Enter type of shape to create:" << endl;
      cin >> answer;
      if (answer == 'R')
	r[i] = new Rectangle (2, 4);
      else
	r[i] = new Square (4);
    }
  output_area ();
  output_types ();

  cout << "Fin du processus\r\n";

  exit (0);
}


/*
 * MAIN
 * ====
 *
 * - Initialise the used managers: tim & bios are initialised at the start-up.
 * - Launch all the processes.
 * - Kill the "main". At this moment only the launched processes are executed.
 *
 */

int
main (void)
{
  uint32 vIDProcess[2];
  int32 status;

  /*
     --------------------------|------------------------------------------------|
   */

  static char prName_0[] = "User 0 process, EF-98                            Rev. 1.00\r\n";
  static char prName_1[] = "User 1 process, EF-98                            Rev. 1.00\r\n";

  status = install_task (prName_0, 800, process_0);
  if (status == -1)
    exit (0);
  vIDProcess[0] = (uint32) status;

  status = install_task (prName_1, 800, process_1);
  if (status == -1)
    exit (0);
  vIDProcess[1] = (uint32) status;

  return 0;
}
