 /*  Interrupt Test */ 
 /*  ================================= */ 
 
.include "reg68336.i"
.include "macros.i"

 /* ------------------------------------------------------------------------ */ 
 /*  Modifs:       Olivier Carmona                 28/8/97                   */ 
 /*  Project:      EXT336                                                    */ 
 /*  Purpose:      Interrupton Generation : needed for the control.          */
 /*  History:                                                                */ 
 /*  Version 1.0:	Initial version.                                     */ 
 /* ------------------------------------------------------------------------ */ 

.globl enable_irq_fcsm,enable_irq_mcsm,disable_irq_mcsm,disable_irq_fcsm
.data

 /* Cette fonction donne le temps d'interrupt */ 
 /*  En entree : Duree (1 unit = 47,68 ns, min = 6.24 ms max = 2.4 s) */ 
 /* -------------------------------------------------------- */ 

 /* in     :       stack           duree des interruptions */ 
 /* out:   - */ 
 /* mod:   F */ 

.text
enable_irq_mcsm:
	/* Initialisation du Prescaler 
           Fixe car utiliser dans newpwm.s pour generer des PWM 
           PCLOCK1 PCLOCK2 PCLOCK3 PCLOCK4 PCLOCK5 PCLOCK6
            fsys/2  fsys/4  fsys/8 fsys/16 fsys/32 fsys/512  */ 
	move.w	#(CPON<<CPRUN)+(CDIV2<<CDIV23)+0b11,CTM_CPCR_CPSM
	/* Modulus Counter Sub Module : Compte a partir de cette valeur */ 
	move.w	#0xffff,CTM_MCSM2ML
	/* Modulus Counter Sub Module : Interrupt level 6, PCLOCK6 */ 
	move.w	#0x6805,CTM_MCSM2SIC
	rts

enable_irq_fcsm:
	/* Initialisation du Prescaler 
           Fixe car utiliser dans newpwm.s pour generer des PWM 
           PCLOCK1 PCLOCK2 PCLOCK3 PCLOCK4 PCLOCK5 PCLOCK6
            fsys/2  fsys/4  fsys/8 fsys/16 fsys/32 fsys/512  */ 
	move.w	#(CPON<<CPRUN)+(CDIV2<<CDIV23)+0b11,CTM_CPCR_CPSM
	/* Modulus Counter Sub Module : Compte a partir de cette valeur */ 
	move.w	#0xffff,CTM_FCSMCNT
	/* Free Counter Sub Module : Interrupt level 4, PCLOCK1 */ 
	move.w	#0x4800,CTM_FCSM12SIC
	rts

disable_irq_mcsm:
	move.w	CTM_MCSM2SIC,D0		 /*  Read the COF bit */ 
	and.w	#0x7FFF,CTM_MCSM2SIC	 /*  Clear the COF bit */ 
	rts

disable_irq_fcsm:
	move.w	CTM_FCSM12SIC,D0		 /*  Read the COF bit */ 
	and.w	#0x7FFF,CTM_FCSM12SIC	 /*  Clear the COF bit */ 
	rts

	
