

 /*  MACROS. */ 
 /*  ======= */ 

 /* ------------------------------------------------------------------------ */ 
 /*  Author:	Franzi Edo.	le 07/03/95 */ 
 /*  Modifs: */ 
 /*  */ 
 /*  Projet:	K-TEAM */ 
 /*  Goal:		Main macros and structures. */ 
 /*  */ 
 /* ------------------------------------------------------------------------ */ 

 aBigPtr	= 0x400		 /*  location of a big ^ on some useful ^ */ 

 /*  Important structures */ 
 /*  ==================== */ 

 /*  Micro-kernel structures */ 
 /*  ----------------------- */ 

	.data

 /*  Modules structures */ 
 /*  ------------------ */ 

 /*  Structure of the process descriptor */ 

 kAPC0		= .

oIDProc:	.long 0		 /*  process ID */ 
oStaProc:	.byte 0		 /*  process state */ 
 bPres		= 0		 /*  process present */ 
 bLock		= 1		 /*  process lock */ 

	.even
oMskEvent:	.long 0		 /*  event mask */ 
oMskSync:	.long 0		 /*  synchro mask */ 
oPtrBelong:	.long 0		 /*  ^ on the belong descriptor */ 
oPtrBack:	.long 0		 /*  ^ on the back descriptor */ 
oPtrForward:	.long 0		 /*  ^ on the forward descriptor */ 
oPtrTextID:	.long 0		 /*  ^ on the descriptor ID text */ 
oTStopProc:	.long 0		 /*  a wait time */ 
oPtrStkPro:	.long 0		 /*  process stack */ 
 kLnStDesc = .-kAPC0		 /*  */ 

 /*  Structure of the  main big ^ table */ 

oPtrFrstMod:	.long 0		 /*  ^ on a first module */ 
oPtrTurOTable:	.long 0		 /*  ^ on a turret order table */ 
oPtrIOChan:	.long 0		 /*  ^ on a I/O channel device */ 
oPtrIDComm:	.long 0		 /*  ^ on a ID communication turret */ 
oPtrStUPSys:	.long 0		 /*  ^ on a flash start-up system */ 
oPtrStUPUsr:	.long 0		 /*  ^ on a flash start-up user */ 
oPtrFrstFreeMe:	.long 0		 /*  ^ on a first free memory */ 
oPtrDownLCode:	.long 0		 /*  ^ on a downloaded code */ 

 /*  Structure of the module header */ 

 kAPC1	=	.

oAdJumpCODE:	.long 0		 /*  jump to the module */ 
oIDModule:	.long 0		 /*  ID of the module T T n n */ 
 kIDFunction	= 'F'<<24+'U'<<16	 /*  F U x x -> stand alone executable function code */ 
 kIDProtocol	= 'P'<<24+'R'<<16	 /*  P R x x -> SerCom protocol function code */ 
 kIDTool	= 'T'<<24+'O'<<16	 /*  T O x x -> SerCom tool function code */ 
 kIDBIOS	= 'B'<<24+'I'<<16	 /*  B I x x -> BIOS */ 
 kIDStartUp	= 'S'<<24+'T'<<16	 /*  S T x x -> Start-up code */ 
 kIDLib		= 'L'<<24+'I'<<16	 /*  L I x x -> LIB */ 
 kIDDebug	= 'D'<<24+'G'<<16	 /*  D G x x -> Debug */ 
 kIDProcess	= 'T'<<24+'A'<<16	 /*  T A x x -> Proc */ 

oPtrCODE:	.long 0		 /*  ^ on the CODE segment */ 
oLnCODE:	.long 0		 /*  lenght of the CODE segment */ 
oPtrDATA:	.long 0		 /*  ^ on the DATA segment */ 
oLnDATA:	.long 0		 /*  lenght of the DATA segment */ 
oPtrStrAppl:	.long 0		 /*  ^ on the string */ 
oRevision:	.byte 0		 /*  "4" major revision */ 
		.byte 0		 /*  "." separator */ 
		.byte 0		 /*  "0" minor revision */ 
		.byte 0		 /*  "1" minor revision (this is an example for a version 4.01) */ 
oPtrStrHelp:	.long 0		 /*  ^ on the help string */ 
oFlType:	.long 0		 /*  type of module */ 
 bShow		= 0		 /*  visible in help */ 
 bExecSerCom	= 1		 /*  executable from SerCom */ 
 bExecRun	= 2		 /*  executable from run */ 
 bConfidential	= 3		 /*  no comment */ 

oDescProc:	.long 0		 /*  ^ on the process descriptor */ 
oRes2:		.long 0		 /*  reserve 2 */ 
oRes1:		.long 0		 /*  reserve 1 */ 

 kLnStModule	= .-kAPC1

 /*  Structure of the process descriptor (pointed by (Ax,oDescProc) */ 

 kAPC2		= .

oPtrProcCode:	.long 0		 /*  ^ on the process code */ 
oPtrProcStack:	.long 0		 /*  ^ on the process stack (to be add. A6) */ 
oPtrProcText:	.long 0		 /*  ^ on the process text ID string */ 
 kLnStDescProc	= .-kAPC2

 /*  Structure of the turret table */ 

 kAPC3		= .

oIDEnt:		.word 0		 /*  turret number and header */ 
oLnMSGGlob:	.byte 0		 /*  size of the order (complete) */ 
oLnMSGUtil:	.byte 0		 /*  size of the order (usuable) */ 
oLnRep:		.byte 0		 /*  size of the answer */ 
oQuitTour:	.byte 0		 /*  acknowledge */ 
 kLnStTabMSG	= .-kAPC3

 /*  Global macros */ 
 /*  ============= */ 

 /*  Modules macros */ 
 /*  -------------- */ 

 /*  Get a ^ A6 on the DATA of the module */ 

	.macro	GETPTR_DATA_A6
	move.l		#aBigPtr,A5
	move.l		(A5,oPtrFrstMod),A0
	move.l		(A0,oPtrDATA),A6
LMACRO_100:
	comp.l		#kIDCModule,(A0,oIDModule)
	beq		LMACRO_101
	add.l		(A0,oLnDATA),A6
	add.l		(A0,oLnCODE),A0
	bra		LMACRO_100

LMACRO_101:
	.endm

 /*  Copyright */ 

	.macro	Copy_Right_Carmona
	.ascii	"(c) Olivier Carmona, LAMI-EPFL, 1996-1999             \r\n"
	.asciz	"Olivier.Carmona@di.epfl.ch                            \r\n"
	.even
	.endm

 /*  Reserve SER channel */ 

	.macro	RESERVE_SER
LMACRO_110:
	CALL_BIOS	ser_reserve_channel,0
	tst.l		D0
	beq		LMACRO_111
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_110

LMACRO_111:
	.endm

 /*  Release SER channel */ 

	.macro	RELEASE_SER
	CALL_BIOS	ser_release_channel,0
	.endm

 /*  Reserve MSG channel */ 

	.macro	RESERVE_MSG
LMACRO_110:
	CALL_BIOS	msg_reserve_channel,0
	tst.l		D0
	beq		LMACRO_111
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_110

LMACRO_111:
	.endm

 /*  Release MSG channel */ 

	.macro	RELEASE_MSG
	CALL_BIOS	msg_release_channel,0
	.endm

 /*  Reserve MMA0 channel */ 

	.macro	RESERVE_MMA0
LMACRO_120:
	CALL_BIOS	mma_reserve_channel_0,0
	tst.l		D0
	beq		LMACRO_121
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_120

LMACRO_121:
	.endm

 /*  Release MMA0 channel */ 

	.macro	RELEASE_MMA0
	CALL_BIOS	mma_release_channel_0,0
	.endm

 /*  Reserve MMA1 channel */ 

	.macro	RESERVE_MMA1
LMACRO_130:
	CALL_BIOS	mma_reserve_channel_1,0
	tst.l		D0
	beq		LMACRO_131
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_130

LMACRO_131:
	.endm

 /*  Release MMA1 channel */ 

	.macro	RELEASE_MMA1
	CALL_BIOS	mma_release_channel_1,0
	.endm

 /*  Reserve MMA2 channel */ 

	.macro	RESERVE_MMA2
LMACRO_140:
	CALL_BIOS	mma_reserve_channel_2,0
	tst.l		D0
	beq		LMACRO_141
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_140

LMACRO_141:
	.endm

 /*  Release MMA2 channel */ 

	.macro	RELEASE_MMA2
	CALL_BIOS	mma_release_channel_2,0
	.endm

 /*  Reserve COM channel */ 

	.macro	RESERVE_COM
LMACRO_150:
	CALL_COM	com_reserve_channel,0
	tst.l		D0
	beq		LMACRO_151
	CALL_BIOS	tim_switch_fast,0
	bra		LMACRO_150

LMACRO_151:
	.endm

 /*  Release COM channel */ 

	.macro	RELEASE_COM
	CALL_COM	com_release_channel,0
	.endm

 /*  Go to Debug mode */ 

	.macro	DEBUGGER
	trap		#7
	.endm

 /*  Debug code */ 

	.macro	DEBUG_CODE n1
	move.b		#\n1,DebExtension
	.endm

 /*  Interruption OFF */ 

	.macro	INTERRUPTION_OFF
	move.w		SR,-(a7)
	move.w		#0x2700,SR
	.endm

 /*  Interruption restored */ 

	.macro	INTERRUPTION_RESTORED
	move.w		(a7)+,SR
	.endm

 /*  Wait a bit (not precise waiting) */ 

	.macro	WAIT n1
	move.l		D0,-(a7)
	move.l		#\n1,D0
LMACRO_160:
	dec.l		D0
	bne		LMACRO_160
	move.l		(a7)+,D0
	.endm

 /*  Send an ASCII buffer (terminated by \0) by the serial link SCI 331 */ 

	.macro	SEND_SCI_BUFFER
	clr.l		D0
LMACRO_170:
	tst.b		QSM_SCSR:#TDRE
	bbc		LMACRO_170
	move.b		(A0)+,D0
	beq		LMACRO_171
	move.w		D0,QSM_SCDR
	bra		LMACRO_170

LMACRO_171:
	.endm

 /*  Send an ASCII buffer (terminated by \0) by the serial link SCI 331 + Radio Modem */ 

	.macro	SEND_MODEM_SCI_BUFFER
	tst.b		GPT_PDR:#bDSR
	bbs		LMACRO_182
LMACRO_180:
	tst.b		GPT_PDR:#bDCD
	bbc		LMACRO_180
LMACRO_181:
	tst.b		GPT_PDR:#bCTS
	bbs		LMACRO_181
LMACRO_182:
	clr.l		D0
LMACRO_183:
	tst.b		QSM_SCSR:#TDRE
	bbc		LMACRO_183
	move.b		(A0)+,D0
	beq		LMACRO_184
	move.w		D0,QSM_SCDR
	bra		LMACRO_183

LMACRO_184:
	.endm

 /*  Send an ASCII buffer (terminated by \0) by the serial link USART 16C450 */ 

	.macro	SEND_USART_BUFFER
	tset.b		DebUSART+MCR:#RTS
LMACRO_190:
	tst.b		DebUSART+LSR:#TEMT
	bbc		LMACRO_190
	move.b		(A0)+,D0
	beq		LMACRO_191
	move.b		D0,DebUSART+THR
	bra		LMACRO_190

LMACRO_191:
	.endm

 /*  Fixed point computation macros */ 
 /*  ------------------------------ */ 

 /*  Fixed point 8.24: multiplication n1 x n2 --> n2 (n3 = tmp.) */ 

 /* 	GenMul824 (n1, n2, n3) */ 

 /*  in:	n1	Val. 1 */ 
 /*  iom:	n2	Val. 2 */ 
 /*  iom:	n3	Reg. tmp */ 
 /*  out:	n2	Result */ 
 /*  mod:	F, n2, n3 */ 

	.macro	GenMul824 n1,n2,n3
	mul.A32		\n1,\n3\n2
	sl.l		#8,\n3
	rl.l		#8,\n2
	and.l		#0x000000FF,\n2
	or.l		\n3,\n2
	.endm

 /*  Fixed point 24.8: conversion int to fixed point */ 
 /*  */ 
 /*  int32 --> 24.8 */ 
 /*  */ 
 /* 	IntToF248 (n1) */ 

 /*  in:	n1	Val. 1 */ 
 /*  out:	n1	Result */ 
 /*  mod:	F, n1 */ 

	.macro	IntToF248 n1
	sl.l		#8,\n1
	.endm

 /*  Fixed point 24.8: conversion fixed point to int */ 
 /*  */ 
 /*  24.8 --> int32 */ 
 /*  */ 
 /* 	F248ToInt (n1) */ 

 /*  in:	n1	Val. 1 */ 
 /*  out:	n1	Result */ 
 /*  mod:	F, n1 */ 

	.macro	F248ToInt n1
	asr.l		#8,\n1
	.endm

 /*  Fixed point 24.8: multiplication n1 x n2 --> n2 (n3 = tmp.) */ 
 /*  */ 
 /*  24.8 x 24.8 --> 24.8 */ 
 /*  */ 
 /* 	GenMulF248 (n1, n2, n3) */ 

 /*  in:	n1	Val. 1 */ 
 /*  iom:	n2	Val. 2 */ 
 /*  iom:	n3	Reg. tmp */ 
 /*  out:	n2	Result */ 
 /*  mod:	F, n2, n3 */ 

	.macro	GenMulF248 n1,n2,n3
	mul.A32		\n1,\n3\n2
	asl.l		#8,\n3
	asl.l		#8,\n3
	asl.l		#8,\n3
	and.l		#0xFF000000,\n3
	sr.l		#8,\n2
	or.l		\n3,\n2
	.endm

 /*  Fixed point 24.8: multiplication n1 x n2 --> n3n2 */ 
 /*  */ 
 /*  24.8 x 24.8 --> 48.w */ 
 /*  */ 
 /* 	GenMul4816 (n1, n2, n3) */ 

 /*  in:	n1	Val. 1 */ 
 /*  iom:	n2	Val. 2 */ 
 /*  iom:	n3	Reg. tmp */ 
 /*  out:	n3	Result MSW */ 
 /*  iom:	n2	Result LSW */ 
 /*  mod:	F, n2, n3 */ 

	.macro	GenMul4816 n1,n2,n3
	mul.A32		\n1,\n3\n2
	.endm

 /*  Fixed point 24.8: division n3n2 / n1 --> n3.r n2:q */ 
 /*  */ 
 /*  48.16 x 24.8 --> 24.8 */ 
 /*  */ 
 /* 	GenDiv4816 (n1, n2, n3) */ 

 /*  in:	n1	Val. 1 */ 
 /*  iom:	n2	Val. 2 */ 
 /*  iom:	n3	Reg. tmp */ 
 /*  out:	n3	Result r */ 
 /*  iom:	n2	Result q */ 
 /*  mod:	F, n2, n3 */ 

	.macro	GenDiv4816 n1,n2,n3
	div.A32		\n1,\n3\n2
	.endm

 /*  Fixed point 24.8: SIGNF248(n1) */ 
 /*  */ 
 /*  24.8 --> 24.8 (+1 si positif, -1 si negatif) */ 
 /*  */ 
 /* 	SIGNF248 (n1) */ 

 /*  in:	n1	Val. */ 
 /*  out:	n1	Result */ 
 /*  mod:	F, n1 */ 

	.macro	SIGNF248 n1
	tst.l		\n1
	bmi		LMACRO_200
	move.l		#0x100,\n1
	bra		LMACRO_201
LMACRO_200:
	move.l		#-0x100,\n1
LMACRO_201:
	.endm

 /*  Fixed point 24.8: ABSF248(n1) */ 
 /*  */ 
 /*  24.8 --> 24.8 */ 
 /*  */ 
 /* 	ABSF248 (n1) */ 

 /*  in:	n1	Val. */ 
 /*  out:	n1	Result */ 
 /*  mod:	F, n1 */ 

	.macro	ABSF248 n1
	tst.l		\n1
	bpl		LMACRO_210
	neg.l		\n1
LMACRO_210:
	.endm

 /*  Fixed point 24.8: NEGF248(n1) */ 
 /*  */ 
 /*  24.8 --> 24.8 */ 
 /*  */ 
 /* 	NEGF248 (n1) */ 

 /*  in:	n1	Val. */ 
 /*  out:	n1	Result */ 
 /*  mod:	F, n1 */ 

	.macro	NEGF248 n1
	neg.l		\n1
	.endm

 /*  TPU macros */ 
 /*  ---------- */ 

 /*  TPU microcode initialisation for channel 0 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH0	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111111111100,TPU_CPR1
	or.w		#0b\n2<<0,TPU_CPR1
	and.w		#0b1111111111110000,TPU_CFSR3
	or.w		#\n1<<0,TPU_CFSR3
	and.w		#0b1111111111111100,TPU_HSQR1
	or.w		#0b\n3<<0,TPU_HSQR1
	and.w		#0b1111111111111100,TPU_CPR1
	or.w		#0b\n4<<0,TPU_CPR1
	and.w		#0b1111111111111110,TPU_CIER
	or.w		#0b\n5<<0,TPU_CIER
	and.w		#0b1111111111111100,TPU_HSRR1
	or.w		#0b\n6<<0,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 1 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH1	 n1, n2,  n3, n4, n5,  n6
	And.w		#0b1111111111110011,TPU_CPR1
	or.w		#0b\n2<<2,TPU_CPR1
	and.w		#0b1111111100001111,TPU_CFSR3
	or.w		#\n1<<4,TPU_CFSR3
	and.w		#0b1111111111110011,TPU_HSQR1
	or.w		#0b\n3<<2,TPU_HSQR1
	and.w		#0b1111111111110011,TPU_CPR1
	or.w		#0b\n4<<2,TPU_CPR1
	and.w		#0b1111111111111101,TPU_CIER
	or.w		#0b\n5<<1,TPU_CIER
	and.w		#0b1111111111110011,TPU_HSRR1
	or.w		#0b\n6<<2,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 2 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH2	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111111001111,TPU_CPR1
	or.w		#0b\n2<<4,TPU_CPR1
	and.w		#0b1111000011111111,TPU_CFSR3
	or.w		#\n1<<8,TPU_CFSR3
	and.w		#0b1111111111001111,TPU_HSQR1
	or.w		#0b\n3<<4,TPU_HSQR1
	and.w		#0b1111111111001111,TPU_CPR1
	or.w		#0b\n4<<4,TPU_CPR1
	and.w		#0b1111111111111011,TPU_CIER
	or.w		#0b\n5<<2,TPU_CIER
	and.w		#0b1111111111001111,TPU_HSRR1
	or.w		#0b\n6<<4,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 3 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH3	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111100111111,TPU_CPR1
	or.w		#0b\n2<<6,TPU_CPR1
	and.w		#0b0000111111111111,TPU_CFSR3
	or.w		#\n1<<12,TPU_CFSR3
	and.w		#0b1111111100111111,TPU_HSQR1
	or.w		#0b\n3<<6,TPU_HSQR1
	and.w		#0b1111111100111111,TPU_CPR1
	or.w		#0b\n4<<6,TPU_CPR1
	and.w		#0b1111111111110111,TPU_CIER
	or.w		#0b\n5<<3,TPU_CIER
	and.w		#0b1111111100111111,TPU_HSRR1
	or.w		#0b\n6<<6,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 4 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH4	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111110011111111,TPU_CPR1
	or.w		#0b\n2<<8,TPU_CPR1
	and.w		#0b1111111111110000,TPU_CFSR2
	or.w		#\n1<<0,TPU_CFSR2
	and.w		#0b1111110011111111,TPU_HSQR1
	or.w		#0b\n3<<8,TPU_HSQR1
	and.w		#0b1111110011111111,TPU_CPR1
	or.w		#0b\n4<<8,TPU_CPR1
	and.w		#0b1111111111101111,TPU_CIER
	or.w		#0b\n5<<4,TPU_CIER
	and.w		#0b1111110011111111,TPU_HSRR1
	or.w		#0b\n6<<8,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 5 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH5	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111001111111111,TPU_CPR1
	or.w		#0b\n2<<10,TPU_CPR1
	and.w		#0b1111111100001111,TPU_CFSR2
	or.w		#\n1<<4,TPU_CFSR2
	and.w		#0b1111001111111111,TPU_HSQR1
	or.w		#0b\n3<<10,TPU_HSQR1
	and.w		#0b1111001111111111,TPU_CPR1
	or.w		#0b\n4<<10,TPU_CPR1
	and.w		#0b1111111111011111,TPU_CIER
	or.w		#0b\n5<<5,TPU_CIER
	and.w		#0b1111001111111111,TPU_HSRR1
	or.w		#0b\n6<<10,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 6 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH6	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1100111111111111,TPU_CPR1
	or.w		#0b\n2<<12,TPU_CPR1
	and.w		#0b1111000011111111,TPU_CFSR2
	or.w		#\n1<<8,TPU_CFSR2
	and.w		#0b1100111111111111,TPU_HSQR1
	or.w		#0b\n3<<12,TPU_HSQR1
	and.w		#0b1100111111111111,TPU_CPR1
	or.w		#0b\n4<<12,TPU_CPR1
	and.w		#0b1111111110111111,TPU_CIER
	or.w		#0b\n5<<6,TPU_CIER
	and.w		#0b1100111111111111,TPU_HSRR1
	or.w		#0b\n6<<12,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 7 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH7	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b0011111111111111,TPU_CPR1
	or.w		#0b\n2<<14,TPU_CPR1
	and.w		#0b0000111111111111,TPU_CFSR2
	or.w		#\n1<<12,TPU_CFSR2
	and.w		#0b0011111111111111,TPU_HSQR1
	or.w		#0b\n3<<14,TPU_HSQR1
	and.w		#0b0011111111111111,TPU_CPR1
	or.w		#0b\n4<<14,TPU_CPR1
	and.w		#0b1111111101111111,TPU_CIER
	or.w		#0b\n5<<7,TPU_CIER
	and.w		#0b0011111111111111,TPU_HSRR1
	or.w		#0b\n6<<14,TPU_HSRR1
	.endm

 /*  TPU microcode initialisation for channel 8 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH8	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111111111100,TPU_CPR0
	or.w		#0b\n2<<0,TPU_CPR0
	and.w		#0b1111111111110000,TPU_CFSR1
	or.w		#\n1<<0,TPU_CFSR1
	and.w		#0b1111111111111100,TPU_HSQR0
	or.w		#0b\n3<<0,TPU_HSQR0
	and.w		#0b1111111111111100,TPU_CPR0
	or.w		#0b\n4<<0,TPU_CPR0
	and.w		#0b1111111011111111,TPU_CIER
	or.w		#0b\n5<<8,TPU_CIER
	and.w		#0b1111111111111100,TPU_HSRR0
	or.w		#0b\n6<<0,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 9 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH9	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111111110011,TPU_CPR0
	or.w		#0b\n2<<2,TPU_CPR0
	and.w		#0b1111111100001111,TPU_CFSR1
	or.w		#\n1<<4,TPU_CFSR1
	and.w		#0b1111111111110011,TPU_HSQR0
	or.w		#0b\n3<<2,TPU_HSQR0
	and.w		#0b1111111111110011,TPU_CPR0
	or.w		#0b\n4<<2,TPU_CPR0
	and.w		#0b1111110111111111,TPU_CIER
	or.w		#0b\n5<<9,TPU_CIER
	and.w		#0b1111111111110011,TPU_HSRR0
	or.w		#0b\n6<<2,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 10 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH10	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111111001111,TPU_CPR0
	or.w		#0b\n2<<4,TPU_CPR0
	and.w		#0b1111000011111111,TPU_CFSR1
	or.w		#\n1<<8,TPU_CFSR1
	and.w		#0b1111111111001111,TPU_HSQR0
	or.w		#0b\n3<<4,TPU_HSQR0
	and.w		#0b1111111111001111,TPU_CPR0
	or.w		#0b\n4<<4,TPU_CPR0
	and.w		#0b1111101111111111,TPU_CIER
	or.w		#0b\n5<<10,TPU_CIER
	and.w		#0b1111111111001111,TPU_HSRR0
	or.w		#0b\n6<<4,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 11 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH11	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111111100111111,TPU_CPR0
	or.w		#0b\n2<<6,TPU_CPR0
	and.w		#0b0000111111111111,TPU_CFSR1
	or.w		#\n1<<12,TPU_CFSR1
	and.w		#0b1111111100111111,TPU_HSQR0
	or.w		#0b\n3<<6,TPU_HSQR0
	and.w		#0b1111111100111111,TPU_CPR0
	or.w		#0b\n4<<6,TPU_CPR0
	and.w		#0b1111011111111111,TPU_CIER
	or.w		#0b\n5<<11,TPU_CIER
	and.w		#0b1111111100111111,TPU_HSRR0
	or.w		#0b\n6<<6,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 12 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH12	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111110011111111,TPU_CPR0
	or.w		#0b\n2<<8,TPU_CPR0
	and.w		#0b1111111111110000,TPU_CFSR0
	or.w		#\n1<<0,TPU_CFSR0
	and.w		#0b1111110011111111,TPU_HSQR0
	or.w		#0b\n3<<8,TPU_HSQR0
	and.w		#0b1111110011111111,TPU_CPR0
	or.w		#0b\n4<<8,TPU_CPR0
	and.w		#0b1110111111111111,TPU_CIER
	or.w		#0b\n5<<12,TPU_CIER
	and.w		#0b1111110011111111,TPU_HSRR0
	or.w		#0b\n6<<8,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 13 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH13	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1111001111111111,TPU_CPR0
	or.w		#0b\n2<<10,TPU_CPR0
	and.w		#0b1111111100001111,TPU_CFSR0
	or.w		#\n1<<4,TPU_CFSR0
	and.w		#0b1111001111111111,TPU_HSQR0
	or.w		#0b\n3<<10,TPU_HSQR0
	and.w		#0b1111001111111111,TPU_CPR0
	or.w		#0b\n4<<10,TPU_CPR0
	and.w		#0b1101111111111111,TPU_CIER
	or.w		#0b\n5<<13,TPU_CIER
	and.w		#0b1111001111111111,TPU_HSRR0
	or.w		#0b\n6<<10,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 14 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH14	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b1100111111111111,TPU_CPR0
	or.w		#0b\n2<<12,TPU_CPR0
	and.w		#0b1111000011111111,TPU_CFSR0
	or.w		#\n1<<8,TPU_CFSR0
	and.w		#0b1100111111111111,TPU_HSQR0
	or.w		#0b\n3<<12,TPU_HSQR0
	and.w		#0b1100111111111111,TPU_CPR0
	or.w		#0b\n4<<12,TPU_CPR0
	and.w		#0b1011111111111111,TPU_CIER
	or.w		#0b\n5<<14,TPU_CIER
	and.w		#0b1100111111111111,TPU_HSRR0
	or.w		#0b\n6<<12,TPU_HSRR0
	.endm

 /*  TPU microcode initialisation for channel 15 */ 
 /* 					CFS, CP, HSB, CP, IE, HSB */ 
	.macro		M_CODE_CH15	 n1, n2,  n3, n4, n5,  n6
	and.w		#0b0011111111111111,TPU_CPR0
	or.w		#0b\n2<<14,TPU_CPR0
	and.w		#0b0000111111111111,TPU_CFSR0
	or.w		#\n1<<12,TPU_CFSR0
	and.w		#0b0011111111111111,TPU_HSQR0
	or.w		#0b\n3<<14,TPU_HSQR0
	and.w		#0b0011111111111111,TPU_CPR0
	or.w		#0b\n4<<14,TPU_CPR0
	and.w		#0b0111111111111111,TPU_CIER
	or.w		#0b\n5<<15,TPU_CIER
	and.w		#0b0011111111111111,TPU_HSRR0
	or.w		#0b\n6<<14,TPU_HSRR0
	.endm

