

 /*  Fichier de dfinition pour le microcontrleur 68336. */ 
 /*  ==================================================== */ 

 /* ------------------------------------------------------------------------ */ 
 /*  Auteur:	Franzi Edo.	le 18/12/96 */ 
 /*  Modifs:	Olivier Carmona. le 15/1/98 */ 
 /*  */ 
 /*  Projet:	K-TEAM */ 
 /*  But:		Dfinitions du fabricant pour le microcontrleur. Ce fichier */ 
 /* 		sera insr pour l'assemblage des applications. */ 
 /*  */ 
 /* ------------------------------------------------------------------------ */ 

 /*  Horloge Processeur */ 

CPU_CLOCK       =20971520

 /*  SIM registres */ 
 /*  ------------- */ 

SIM_MCR		= 0xFFFA00	 /*  Module Configuration Register */ 
 SIARB0	= 0		 /*  Interrupt arbitration bit 0 */ 
 SIARB1	= 1		 /*  Interrupt arbitration bit 1 */ 
 SIARB2	= 2		 /*  Interrupt arbitration bit 2 */ 
 SIARB3	= 3		 /*  Interrupt arbitration bit 3 */ 
 SMM	= 6			 /*  Module mapping */ 
 SSUPV	= 7			 /*  Supervisor/Unrestricted data space */ 
 SSHEN0	= 8		 /*  Show cycle enable 0 */ 
 SSHEN1	= 9		 /*  Show cycle enable 1 */ 
 SSLVEN	= 11		 /*  Slave mode enabled */ 
 SFRZBM	= 13		 /*  Freeze bus monitor enable */ 
 SFRZSW	= 14		 /*  Free software enable */ 
 SEXOFF	= 15		 /*  External clock off */ 

SIM_MTR		= 0xFFFA02	 /*  Module Test Register */ 

SIM_SYNCR	= 0xFFFA04	 /*  Clock Synthesizer Control Register */ 
 STEXT	= 0		 /*  Stop mode external clock */ 
 STSIM	= 1		 /*  Stop mode system integration clock */ 
 RSVD0	= 2		 /*  Reserved */ 
 SLOCK	= 3		 /*  Synthesizer lock */ 
 RSVD1	= 4		 /*  Reserved */ 
 EDIV	= 7		 /*  E clock divide rate */ 
 X	= 14		 /*  Frequency control bit */ 
 W	= 15		 /*  Frequency control bit */ 

SIM_RSR		= 0xFFFA07	 /*  Reset Status Register */ 
 TST	= 0		 /*  Test submodul reset */ 
 SYS	= 1		 /*  System reset */ 
 LOC	= 2		 /*  Loss of clock reset */ 
 HLT	= 4		 /*  Halt monitor reset */ 
 SW	= 5		 /*  Software Watchdog reset */ 
 POW	= 6		 /*  Power-up reset */ 
 EXT	= 7		 /*  External reset */ 

SIM_SIMTRE	= 0xFFFA08	 /*  Module Test Register */ 

SIM_PORTE	= 0xFFFA11	 /*  Port E0 Data Register */ 

SIM_PORTE1	= 0xFFFA13	 /*  Port E1 Data Register */ 

SIM_DDRE	= 0xFFFA15	 /*  Port E Data Direction Register */ 

SIM_PEPAR	= 0xFFFA17	 /*  Port E Pin Assignment Register */ 

SIM_PORTF	= 0xFFFA19	 /*  Port F0 Data Register */ 

SIM_PORTF1	= 0xFFFA1B	 /*  Port F1 Data Register */ 

SIM_DDRF	= 0xFFFA1D	 /*  Port F Data Direction Register */ 

SIM_PFPAR	= 0xFFFA1F	 /*  Port F Pin Assignment Register */ 

SIM_SYPCR	= 0xFFFA21	 /*  System Protection Control */ 
 BME	= 2		 /*  Bus Moniteur external enable */ 
 HME	= 3		 /*  Halt monitor enable */ 
 SWP	= 6		 /*  Software watchdog prescaler */ 
 SWE	= 7		 /*  Software watchdog enable */ 

SIM_PICR	= 0xFFFA22	 /*  Periodic Interrupt Controller */ 

SIM_PITR	= 0xFFFA24	 /*  Periodic Interrupt Timing Controller */ 

SIM_SWSR	= 0xFFFA27	 /*  Software Service Register */ 

SIM_TSTMSRA	= 0xFFFA30	 /*  Master Shift Register A */ 

SIM_TSTMSRB	= 0xFFFA32	 /*  Master Shift Register B */ 

SIM_TSTSCA	= 0xFFFA34	 /*  Shift Count Register A and Counter A */ 

SIM_TSTSCB	= 0xFFFA35	 /*  Shift Count Register B and Counter B */ 

SIM_TSTRC	= 0xFFFA36	 /*  Test Module Repetition Counter */ 

SIM_CREG	= 0xFFFA38	 /*  Test Submodule Control Register */ 
 ETM	= 0		 /*  Enter test mode */ 
 SATO	= 1		 /*  Start automatic test operation */ 
 SSHOP	= 2		 /*  Starting shifting operation */ 
 SCONT	= 3		 /*  Start continuous operation */ 
 ACUT	= 4		 /*  Activate circuit under test */ 
 MUXSEL	= 9		 /*  Multiplexer select mode */ 
 QBIT	= 10		 /*  Quotient bit */ 
 CPUTR	= 11		 /*  CPU test register */ 
 IMBTST	= 12		 /*  Intermodule test register */ 
 COMP	= 13		 /*  Compare status bit */ 
 TMARM	= 14		 /*  Test mode armed status bit */ 
 BUSY	= 15		 /*  Test submodul busy status bit */ 

SIM_DREG	= 0xFFFA3A	 /*  Distributed Register */ 

SIM_CSPDR	= 0xFFFA41	 /*  Chip Select Pin Data Register */ 
 
SIM_CSPAR0	= 0xFFFA44	 /*  */ 
SIM_CSPAR1	= 0xFFFA46	 /*  */ 
 DiOu	= 0b00		 /*  discrete output */ 
 AlFu	= 0b01		 /*  default function */ 
 CS8	= 0b10		 /*  chip select (8 bit port) */ 
 CS16	= 0b11		 /*  chip select (16 bit port) */ 

SIM_CSBARBT	= 0xFFFA48	 /*  */ 
SIM_CSBAR0	= 0xFFFA4C	 /*  */ 
SIM_CSBAR1	= 0xFFFA50	 /*  */ 
SIM_CSBAR2	= 0xFFFA54	 /*  */ 
SIM_CSBAR3	= 0xFFFA58	 /*  */ 
SIM_CSBAR4	= 0xFFFA5C	 /*  */ 
SIM_CSBAR5	= 0xFFFA60	 /*  */ 
SIM_CSBAR6	= 0xFFFA64	 /*  */ 
SIM_CSBAR7	= 0xFFFA68	 /*  */ 
SIM_CSBAR8	= 0xFFFA6C	 /*  */ 
SIM_CSBAR9	= 0xFFFA70	 /*  */ 
SIM_CSBAR10	= 0xFFFA74	 /*  */ 
 S2K	= 0b000		 /*  2 KByte */ 
 S8K	= 0b001		 /*  8 KByte */ 
 S16K	= 0b010		 /*  16 KByte */ 
 S64K	= 0b011		 /*  64 KByte */ 
 S128K	= 0b100		 /*  128 KByte */ 
 S256K	= 0b101		 /*  256 KByte */ 
 S512K	= 0b110		 /*  512 KByte */ 
 S1M	= 0b111		 /*  1 MByte */ 

SIM_CSORBT	= 0xFFFA4A	 /*  */ 
SIM_CSOR0	= 0xFFFA4E	 /*  */ 
SIM_CSOR1	= 0xFFFA52	 /*  */ 
SIM_CSOR2	= 0xFFFA56	 /*  */ 
SIM_CSOR3	= 0xFFFA5A	 /*  */ 
SIM_CSOR4	= 0xFFFA5E	 /*   */ 
SIM_CSOR5	= 0xFFFA62	 /*   */ 
SIM_CSOR6	= 0xFFFA66	 /*   */ 
SIM_CSOR7	= 0xFFFA6A	 /*   */ 
SIM_CSOR8	= 0xFFFA6E	 /*   */ 
SIM_CSOR9	= 0xFFFA72	 /*   */ 
SIM_CSOR10	= 0xFFFA76	 /*  Chip Select Pin Assignment Register */ 
 AVOff	= 0b0		 /*  AVEC off */ 
 AVOn	= 0b1		 /*  AVEC on */ 

 LAll	= 0b000		 /*  All */ 
 LEVEL1	= 0b001		 /*  level 1 CHANGED FROM L1 TO LEVEL1 */ 
 LEVEL2	= 0b010		 /*  level 2 CHANGED FROM L2 TO LEVEL2 */ 
 LEVEL3	= 0b011		 /*  level 3 CHANGED FROM L3 TO LEVEL3 */ 
 LEVEL4	= 0b100		 /*  level 4 CHANGED FROM L4 TO LEVEL4 */ 
 LEVEL5	= 0b101		 /*  level 5 CHANGED FROM L5 TO LEVEL5 */ 
 LEVEL6	= 0b110		 /*  level 6 CHANGED FROM L6 TO LEVEL6 */ 
 LEVEL7	= 0b111		 /*  level 7 CHANGED FROM L7 TO LEVEL7 */ 

 CPUSP	= 0b00		 /*  space CPU */ 
 UserSP	= 0b01		 /*  space User */ 
 SuperSP= 0b10		 /*  space Supervisor */ 
 SUSP	= 0b11		 /*  space both (U/S) */ 

 W0	= 0b0000	 /*  0 wait states */ 
 W1	= 0b0001	 /*  1 wait states */ 
 W2	= 0b0010	 /*  2 wait states */ 
 W3	= 0b0011	 /*  3 wait states */ 
 W4	= 0b0100	 /*  4 wait states */ 
 W5	= 0b0101	 /*  5 wait states */ 
 W6	= 0b0110	 /*  6 wait states */ 
 W7	= 0b0111	 /*  7 wait states */ 
 W8	= 0b1000	 /*  8 wait states */ 
 W9	= 0b1001	 /*  9 wait states */ 
 W10	= 0b1010	 /*  10 wait states */ 
 W11	= 0b1011	 /*  11 wait states */ 
 W12	= 0b1100	 /*  12 wait states */ 
 W13	= 0b1101	 /*  13 wait states */ 
 FTerm	= 0b1110	 /*  fast termination */ 
 Exter	= 0b1111	 /*  external DSACKx */ 

 AS	= 0b0		 /*  AS strobe */ 
 DS	= 0b1		 /*  DS strobe */ 

 Rsvd	= 0b00		 /*  reserved */ 
 Read	= 0b01		 /*  only read */ 
 Write	= 0b10		 /*  only write */ 
 Both	= 0b11		 /*  read/write */ 

 BOff	= 0b00		 /*  off */ 
 BBLower= 0b01		 /*  lower byte */ 
 BUpper	= 0b10		 /*  upper byte */ 
 BLU	= 0b11		 /*  lower/upper */ 

 ASYNC	= 0b0		 /*  asynchronous mode */ 
 SYNC	= 0b1		 /*  synchronous mode */ 

 /*  QSM registres */ 
 /*  ------------- */ 

QSM_QMCR	= 0xFFFC00	 /*  Configuration Register */ 
 QIARB0	= 0		 /*  Interrupt arbitration bit 0 */ 
 QIARB1	= 1		 /*  Interrupt arbitration bit 1 */ 
 QIARB2	= 2		 /*  Interrupt arbitration bit 2 */ 
 QIARB3	= 3		 /*  Interrupt arbitration bit 3 */ 
 QSUPV	= 7		 /*  Supervisor/Unrestricted data space */ 
 QFRZBM	= 13		 /*  Freeze bus monitor enable */ 
 QFRZSW	= 14		 /*  Free software enable */ 
 QSTOP	= 15		 /*  Stop enable */ 

QSM_QTEST	= 0xFFFC02	 /*  QSM Test Register */ 
 QTMM	= 0		 /*  Test memory map */ 
 QTQSM	= 1		 /*  QSM Test enable */ 
 QSYNC	= 2		 /*  SCI bits/s clock syncro signal */ 
 QTSBD	= 3		 /*  SPI Test scan path selec */ 

QSM_QILR_IVR	= 0xFFFC04	 /*  QSM Interrupt Level Register and QSM Interrupt Vector Register */ 

QSM_SCCR0	= 0xFFFC08	 /*  SCI Control Register */ 
QSM_SCCR1	= 0xFFFC0A	 /*  SCI Control Register */ 
 SBK	= 0		 /*  Send break */ 
 RWU	= 1		 /*  Receiver wakeup */ 
 RE	= 2		 /*  Receiver enable */ 
 TE	= 3		 /*  Transmitter enable */ 
 ILIE	= 4		 /*  Idle line interrupt enable */ 
 RIE	= 5		 /*  Receiver interrupt enable */ 
 TCIE	= 6		 /*  Transmit complet interrupt enable  */ 
 TIE	= 7		 /*  Transmit interrupt enable */ 
 WAKE	= 8		 /*  Wakeup by adress mark */ 
 M	= 9		 /*  Mode select */ 
 PE	= 10		 /*  Parity enable */ 
 PT	= 11		 /*  Parity type */ 
 ILT	= 12		 /*  Idle line detect type */ 
 WOMS	= 13		 /*  Wired or for SCI pins */ 
 LOOPS	= 14		 /*  Loop mode */ 
 
QSM_SCSR	= 0xFFFC0C	 /*  SCI Status Register */ 
 PF	= 0		 /*  Parity flag error */ 
 FE	= 1		 /*  Framming error */ 
 NF	= 2		 /*  Noise error flag */ 
 OR	= 3		 /*  Overrun error flag */ 
 IDLE	= 4		 /*  Idle line detected flag */ 
 RAF	= 5		 /*  Receiver active flag */ 
 RDRF	= 6		 /*  Receive data registre full */ 
 TC	= 7		 /*  Transmit complet flag */ 
 TDRE	= 8		 /*  Transmit data register empty flag */ 
 
QSM_SCDR	= 0xFFFC0E	 /*  SCI Data Register */ 

QSM_PORTQS	= 0xFFFC14	 /*  QSM Port QS Data Register */ 

QSM_PQSPARDDRQS	= 0xFFFC16	 /*  QSM Pin Assignement Register and QSM Data Direction Register */ 

QSM_SPCR0	= 0xFFFC18	 /*  QSM QSPI Control Register 0 */ 
 QCPHA	= 9		 /*  Clock phase */ 
 QCPOL	= 10		 /*  Clock polarity */ 
 QWOMQ	= 14		 /*  Wired-OR mode for QSPI pins */ 
 QMSTR	= 15		 /*  Master/Slave clock select */ 

QSM_SPCR1	= 0xFFFC1A	 /*  QSM QSPI Control Register 1 */ 
 QSPE	= 15		 /*  QSPI Enable */ 

QSM_SPCR2	= 0xFFFC1C	 /*  QSM QSPI Control Register 2 */ 
 QWRTO	= 13		 /*  Wrap to */ 
 QWREN	= 14		 /*  Wrap Enable */ 
 QSPIFI	= 15		 /*  SPI Finished interrupt enable */ 

QSM_SPCR3SPSR	= 0xFFFC1E	 /*  QSM QSPI Control Register 3 and QSPI Status Register */ 
 QHALTA	= 5		 /*  Halt acknowledge flag */ 
 QMODF	= 6		 /*  Mode fault flag */ 
 QSPIF	= 7		 /*  QSPI Finished flag */ 
 QHALT	= 8		 /*  HALT */ 
 QHMIE	= 9		 /*  HALTA and MODF interrupt enable */ 
 QLOOPQ	= 10		 /*  QSPI Loop mode */ 

QSM_SPSR	= 0xFFFC1E	 /*  QSM QSPI Control Register 3 */ 

QSM_RECRAM	= 0xFFFD00	 /*  QSM Reception RAM from xxD00 to xx D1F */ 
QSM_TRARAM	= 0xFFFD20	 /*  QSM Transmitter RAM from xxD20 to xx D3F */ 

QSM_COMDRAM	= 0xFFFD40	 /*  QSM Command RAM from xxD40 to xx D4F */ 

 /*  CTM registres */ 
 /*  ------------- */ 

CTM_BIUMCR      = 0xFFF400               /*  BIU Module Configuration Register */ 
 CTBRS0         = 0                      /*  Time Base Register Bus Select Bits */ 
 CTBRS1         = 5                      /*  Time Base Register Bus Select Bits */ 
 CFRZ           = 14                     /*  FREEZE Assertion Response */ 
 CSTOP          = 15                     /*  Low-Power Stop Mode Enable */ 

CTM_BIUTEST     = 0xFFF402               /*  BIUSM Test Configuration Register */ 

CTM_BIUTBR      = 0xFFF404               /*  BIUSM Time Base Register */ 
CTM_CPCR_CPSM   = 0xFFF408               /*  CPCR CPSM Control Register */ 
 CDIV23         = 2                      /*  Divide by 2/ divide by 3 */ 
    CDIV2         = 0
    CDIV3         = 1
 CPRUN          = 3                      /*  Prescaler Running */ 
    CPOFF       = 0
    CPON        = 1

CTM_CPTR        = 0xFFF40A               /*  CPSM Test Register (factory test) */ 

CTM_FCSM12SIC     = 0xFFF460               /*  FCSM Satus / Interrupt / Control register */ 
 CIN            = 7                      /*  Clock Input Pin Status */ 
 CDRVB          = 8                      /*  Drive Time Base Bus */ 
 CDRVA          = 9                      /*  Drive Time Base Bus */ 
 CIARB3         = 11                     /*  Interrupt Arbitration Bit 3 */ 
 CCOF           = 15                     /*  Counter Overflow Flag */ 

CTM_FCSMCNT     = 0xFFF462               /*  FCSM Counter Register */ 

CTM_MCSM2SIC    = 0xFFF410               /*  MCSM2 Status / Interrupt / Control register */ 
CTM_MCSM11SIC   = 0xFFF458               /*  MCSM11 Status / Interrupt / Control register */ 
 CEDGEP         = 4                      /*  Modulus Load Edge Sensivity Bit */ 
 CEDGEN         = 5                      /*  Modulus Load Edge Sensivity Bit */ 
 CIN1           = 6                      /*  Modulus Load Input Pin Status */ 
 CIN2           = 7                      /*  Modulus Load Input Pin Status */ 
 CDRVB          = 8                      /*  Drive Time Base Bus */ 
 CDRVA          = 9                      /*  Drive Time Base Bus */ 
 CIARB3         = 11                     /*  Interrupt Arbitration Bit 3 */ 
 CCOF           = 15                     /*  Counter Overflow Flag */ 

CTM_MCSM2CNT    = 0xFFF412               /* MCSM2 Counter Register */ 
CTM_MCSM11CNT   = 0xFFF45A               /* MCSM11 Counter Register */ 

CTM_MCSM2ML     = 0xFFF412               /* MCSM2 Modulus Latch */ 
CTM_MCSM11ML    = 0xFFF45A               /* MCSM11 Modulus Latch */ 

CTMDASM3SIC     = 0xFFF418               /*  DASM3 Status / Interrupt / Control register */ 
CTMDASM4SIC     = 0xFFF420               /*  DASM4 Status / Interrupt / Control register */ 
CTMDASM9SIC     = 0xFFF448               /*  DASM9 Status / Interrupt / Control register */ 
CTMDASM10SIC    = 0xFFF450               /*  DASM10 Status / Interrupt / Control register */ 
 CMODE          = 0										 /*  Mode */ 
 	CDDIS			= 0b0000						 /*  Disabled */ 
	CDIPWM      = 0b0001                 /*  Input Pulse Width Measurement */ 
	CDIPM       = 0b0010                 /*  Input Period Measurement */ 
	CDIC        = 0b0011                 /*  Input Capture */ 
	CDOCA       = 0b0100                 /*  Output Compare flag set on B */ 
	CDOCB       = 0b0101                 /*  Output Compare flag set on A and B */ 
	CDOPWM      = 0b1000                 /*  Generate Output PWM */ 
 CEDPOL         = 4                      /*  Edge Polarity Bit */ 
 CFORCB         = 5                      /*  Force B */ 
 CFORCA         = 6                      /*  Force A */ 
 CIN            = 7                      /*  Input Pin Status */ 
 CBSL           = 8                      /*  Time Bus Select */ 
    CTBA        = 0                      /*  Time Bus A */ 
    CTBB        = 1                      /*  Time Bus B */ 
 CWOR           = 9                      /*  Wired-OR Mode */ 
    CTP         = 0                      /*  In Ouput Mode : Totem Pole output */ 
    COD         = 1                      /*  In Ouput Mode : Open Drain output */ 
 CIARB3         = 11                     /*  Interrupt Arbitration Bit 3 */ 
 CFLAG          = 15                     /*  Event Flag */ 

CTM_DASM3A      = 0xFFF41A               /*  DASM3 Data Register A */ 
CTM_DASM4A      = 0xFFF422               /*  DASM4 Data Register A */ 
CTM_DASM9A      = 0xFFF44A               /*  DASM9 Data Register A */ 
CTM_DASM10A     = 0xFFF452               /*  DASM10 Data Register A */ 

CTM_DASM3B      = 0xFFF41C               /*  DASM3 Data Register B */ 
CTM_DASM4B      = 0xFFF424               /*  DASM4 Data Register B */ 
CTM_DASM9B      = 0xFFF44C               /*  DASM9 Data Register B */ 
CTM_DASM10B     = 0xFFF454               /*  DASM10 Data Register B */ 

CTM_PWM5SIC     = 0xFFF428               /*  PWM5 Status / Interrupt / Control Register */ 
CTM_PWM6SIC     = 0xFFF430               /*  PWM6 Status / Interrupt / Control Register */ 
CTM_PWM7SIC     = 0xFFF438               /*  PWM7 Status / Interrupt / Control Register */ 
CTM_PWM8SIC     = 0xFFF440               /*  PWM8 Status / Interrupt / Control Register */ 
 CEN            = 3                      /*  PWMSM Enable */ 
 CPOL           = 4                      /*  Output Pin Polarity Control */ 
 CLOAD          = 5                      /*  Period and Pulse Width Register Load control */ 
 CPIN           = 7                      /*  Output Pin Status */ 
 CIARB3         = 11                     /*  Interrupt Arbitration Bit 3 */ 
 CFLAG          = 15                     /*  Event Flag */ 

CTM_PWM5A1      = 0xFFF42A               /*  PWM5A Period Register */ 
CTM_PWM6A1      = 0xFFF432               /*  PWM6A Period Register */ 
CTM_PWM7A1      = 0xFFF43A               /*  PWM7A Period Register */ 
CTM_PWM8A1      = 0xFFF442               /*  PWM8A Period Register */ 

CTM_PWM5B1      = 0xFFF42C               /*  PWM5B Period Register */ 
CTM_PWM6B1      = 0xFFF434               /*  PWM6B Period Register */ 
CTM_PWM7B1      = 0xFFF43C               /*  PWM7B Period Register */ 
CTM_PWM8B1      = 0xFFF444               /*  PWM8B Period Register */ 

CTM_PWM5C1      = 0xFFF42E               /*  PWM5C Period Register */ 
CTM_PWM6C1      = 0xFFF436               /*  PWM6C Period Register */ 
CTM_PWM7C1      = 0xFFF43E               /*  PWM7C Period Register */ 
CTM_PWM8C1      = 0xFFF446               /*  PWM8C Period Register */ 

 /*  TPU (mask G) registres */ 
 /*  ---------------------- */ 

TPU_TMCR	= 0xFFFE00	 /*  Configuration Register */ 
 TIARB0	= 0		 /*  Interrupt arbitration bit 0 */ 
 TIARB1	= 1		 /*  Interrupt arbitration bit 1 */ 
 TIARB2	= 2		 /*  Interrupt arbitration bit 2 */ 
 TIARB3	= 3		 /*  Interrupt arbitration bit 3 */ 
 PSCK	= 6		 /*  Prescaler clock */ 
 TSUPV	= 7		 /*  Supervisor/Unrestricted data space */ 
 STF	= 8		 /*  Stop flag */ 
 T2CG	= 9		 /*  Clock/gate Control */ 
 EMU	= 10		 /*  Emulation Control */ 
 TCR2P0	= 11		 /*  Timer Count Register 2 Prescaler Control bit 0 */ 
 TCR2P1	= 12		 /*  Timer Count Register 2 Prescaler Control bit 1 */ 
 TCR1P0	= 13		 /*  Timer Count Register 1 Prescaler Control bit 0 */ 
 TCR1P1	= 14		 /*  Timer Count Register 1 Prescaler Control bit 1 */ 
 TSTOP	= 15		 /*  Stop bit */ 

TPU_TPUTCR	= 0xFFFE02	 /*  TPU test Configuration Register */ 

TPU_DSCR	= 0xFFFE04	 /*  Development Support Control Register */ 

TPU_DSSR	= 0xFFFE06	 /*  Development Support Status Register */ 

TPU_TICR	= 0xFFFE08	 /*  TPU Interruption Configuration Register */ 

TPU_CIER	= 0xFFFE0A	 /*  Channel Interruption Enable Register */ 

TPU_CFSR0	= 0xFFFE0C	 /*  Channel Function Select Register 0 */ 
TPU_CFSR1	= 0xFFFE0E	 /*  Channel Function Select Register 1 */ 
TPU_CFSR2	= 0xFFFE10	 /*  Channel Function Select Register 2 */ 
TPU_CFSR3	= 0xFFFE12	 /*  Channel Function Select Register 3 */ 
 FQD	= 0x06		 /*  Fast Quadrature Decode */ 
 MCPWM	= 0x07		 /*  Multichannel PWM */ 
 HALLD	= 0x08		 /*  Hall Effect Decode */ 
 COMM	= 0x09		 /*  Multiphase Motor Commutation */ 
 NITC	= 0x0A		 /*  New Input Transition Counter */ 
 UART	= 0x0B		 /*  Asynchronous Receiver/Transmit */ 
 FQM	= 0x0C		 /*  Frequency Measurement */ 
 TSM	= 0x0D		 /*  Table Stepper Motor */ 
 QOM	= 0x0E		 /*  Queued Output Match */ 
 PTA	= 0x0F		 /*  Programmable Timer Accumulator */ 

TPU_HSQR0	= 0xFFFE14	 /*  Host Sequence Register 0 */ 
TPU_HSQR1	= 0xFFFE16	 /*  Host Sequence Register 1 */ 

TPU_HSRR0	= 0xFFFE18	 /*  Host Service Request Register 0 */ 
TPU_HSRR1	= 0xFFFE1A	 /*  Host Service Request Register 1 */ 

TPU_CPR0	= 0xFFFE1C	 /*  Channel Priority Register 0 */ 
TPU_CPR1	= 0xFFFE1E	 /*  Channel Priority Register 1 */ 

TPU_CISR	= 0xFFFE20	 /*  Channel Interruption Status Register */ 

TPUPRAM_CH00	= 0xFFFF00	 /*  Channel 00 Parameter Registers */ 
TPUPRAM_CH01	= 0xFFFF10	 /*  Channel 01 Parameter Registers */ 
TPUPRAM_CH02	= 0xFFFF20	 /*  Channel 02 Parameter Registers */ 
TPUPRAM_CH03	= 0xFFFF30	 /*  Channel 03 Parameter Registers */ 
TPUPRAM_CH04	= 0xFFFF40	 /*  Channel 04 Parameter Registers */ 
TPUPRAM_CH05	= 0xFFFF50	 /*  Channel 05 Parameter Registers */ 
TPUPRAM_CH06	= 0xFFFF60	 /*  Channel 06 Parameter Registers */ 
TPUPRAM_CH07	= 0xFFFF70	 /*  Channel 07 Parameter Registers */ 
TPUPRAM_CH08	= 0xFFFF80	 /*  Channel 08 Parameter Registers */ 
TPUPRAM_CH09	= 0xFFFF90	 /*  Channel 09 Parameter Registers */ 
TPUPRAM_CH10	= 0xFFFFA0	 /*  Channel 10 Parameter Registers */ 
TPUPRAM_CH11	= 0xFFFFB0	 /*  Channel 11 Parameter Registers */ 
TPUPRAM_CH12	= 0xFFFFC0	 /*  Channel 12 Parameter Registers */ 
TPUPRAM_CH13	= 0xFFFFD0	 /*  Channel 13 Parameter Registers */ 
TPUPRAM_CH14	= 0xFFFFE0	 /*  Channel 14 Parameter Registers */ 
TPUPRAM_CH15	= 0xFFFFF0	 /*  Channel 15 Parameter Registers */ 

bCH00	= 0		 /*  channel 0 */ 
bCH01	= 1		 /*  channel 1 */ 
bCH02	= 2		 /*  channel 2 */ 
bCH03	= 3		 /*  channel 3 */ 
bCH04	= 4		 /*  channel 4 */ 
bCH05	= 5		 /*  channel 5 */ 
bCH06	= 6		 /*  channel 6 */ 
bCH07	= 7		 /*  channel 7 */ 
bCH08	= 8		 /*  channel 8 */ 
bCH09	= 9		 /*  channel 9 */ 
bCH10	= 10		 /*  channel 10 */ 
bCH11	= 11		 /*  channel 11 */ 
bCH12	= 12		 /*  channel 12 */ 
bCH13	= 13		 /*  channel 13 */ 
bCH14	= 14		 /*  channel 14 */ 
bCH15	= 15		 /*  channel 15 */ 

 /*  QADC registres */ 
 /*  -------------- */ 

QADC_QMCR	= 0xFFF200	 /*  Configuration Register */ 
 AIARB0	= 0		 /*  Interrupt arbitration bit 0 */ 
 AIARB1	= 1		 /*  Interrupt arbitration bit 1 */ 
 AIARB2	= 2		 /*  Interrupt arbitration bit 2 */ 
 AIARB3	= 3		 /*  Interrupt arbitration bit 3 */ 
 ASUPV	= 7		 /*  Supervisor/Unrestricted data space */ 
 AFRZ	= 14		 /*  Finish any current conversion, then freeze */ 
 ASTOP	= 15		 /*  Stop bit */ 

QADC_QADCTEST	= 0xFFF202	 /*  QADC test Configuration Register */ 

QADC_QADCINT	= 0xFFF204	 /*  QADC Interrupt Register */ 

QADC_PORTQA	= 0xFFF206	 /*  Port A Data Register */ 

QADC_PORTQB	= 0xFFF207	 /*  Port B Data Register */ 

QADC_DDRQA	= 0xFFF208	 /*  Port A Data Direction Register */ 

QADC_QACR0	= 0xFFF20A	 /*  Control Register 0 */ 
 PSA	= 3		 /*  Prescaler Add a Clock Half Cycle */ 
 MUX	= 15		 /*  Externally Multiplexed Mode */ 

QADC_QACR1	= 0xFFF20C	 /*  Control Register 1 */ 
 SSE1	= 13		 /*  Queue 1 Single Scann Enable Bit */ 
 PIE1	= 14		 /*  Queue 1 Pause Interrupt Enable */ 
 CIE1	= 15		 /*  Queue 1 Completion Interrupt Enable */ 

QADC_QACR2	= 0xFFF20E	 /*  Control Register 2 */ 
 SSE2	= 13		 /*  Queue 2 Single Scann Enable Bit */ 
 PIE2	= 14		 /*  Queue 2 Pause Interrupt Enable */ 
 CIE2	= 15		 /*  Queue 2 Completion Interrupt Enable */ 

QADC_QASR	= 0xFFF210	 /*  Status Register */ 
 TOR2	= 10		 /*  Queue 2 Trigger Overrun */ 
 TOR1	= 11		 /*  Queue 1 Trigger Overrun */ 
 PF2	= 12		 /*  Queue 2 Pause Flag */ 
 CF2	= 13		 /*  Queue 2 Completion Flag */ 
 PF1	= 14		 /*  Queue 1 Pause Flag */ 
 CF1	= 15		 /*  Queue 1 Completion Flag */ 

QADC_CCW	= 0xFFF230	 /*  Conversion Command Word Table */ 

QADC_RJURR	= 0xFFF2B0	 /*  Right Justified Unsigned Result Word Table */ 

QADC_LJSRR	= 0xFFF330	 /*  Left Justified Signed Result Word Table */ 

QADC_LJURR	= 0xFFF3B0	 /*  Left Justified Unsigned Result Word Table */ 

