/* ====================================================
 * Approximation of sin(x) in [0,pi/2]
 * Split the domain in two, resulting in two table 
 * lookup function for a better precision.
 * Input / Output Number Representation: 0.32 bits
 *
 * Copyright (C) 2000 by K-Team, S.A. All rights reserved.
 *
 * Developed at K-Team S.A by Olivier Carmona.
 *
 * Permission to use, copy, modify, and distribute this
 * software is freely granted, provided that this notice
 * is preserved.
 *
 * There is no warranty for this free software.  If the software is modified
 * by someone else and passed on, we want its recipients to know that
 * what they have is not the original, so that any problems introduced
 * by others will not reflect on the original authors' reputations.
 *
 * ====================================================
 */

/*
  N.B.:
  AOUT Compiler imply labeling functions with an _
 */

.globl sin_lkup1,sin_lkup2

sin_lkup1:
	movem.l			d2/a2,-(a7)
	move.l			12(a7),d2
        lea                     (aTabSin1,pc),a2
	tblu.l			(a2),d2
	move.l			d2,d0
	movem.l			(a7)+,d2/a2
	rts

sin_lkup2:
	movem.l			d2/a2,-(a7)
	move.l			12(a7),d2
        lea                     (aTabSin2,pc),a2
	tblu.l			(a2),d2
	move.l			d2,d0
	movem.l			(a7)+,d2/a2
	rts

	.include "sina.i"

